﻿using System.Text;

namespace TestProject
{
    /// <summary>
    /// 문자열 헬퍼
    /// </summary>
    public static class StringHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 반복 문자열 구하기 - GetRepeatString(source, repeatCount)

        /// <summary>
        /// 반복 문자열 구하기
        /// </summary>
        /// <param name="source">소스 문자열</param>
        /// <param name="repeatCount">반복 횟수</param>
        /// <returns>반복 문자열</returns>
        public static string GetRepeatString(this string source, int repeatCount)
        {
            StringBuilder stringBuilder = new StringBuilder();

            for(int i = 0; i < repeatCount; i++)
            {
                stringBuilder.Append(source);
            }

            string target = stringBuilder.ToString();

            return target;
        }

        #endregion
    }
}