﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// cluster
    /// </summary>
    public class cluster
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주소 - addr

        /// <summary>
        /// 주소
        /// </summary>
        public string addr { get; set; }

        #endregion
        #region 클러스터 포트 - cluster_port

        /// <summary>
        /// 클러스터 포트
        /// </summary>
        public int cluster_port { get; set; }

        #endregion
        #region 인증 타임아웃 - auth_timeout

        /// <summary>
        /// 인증 타임아웃
        /// </summary>
        public int auth_timeout { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString(indentCount)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="indentCount">들여쓰기 카운트</param>
        /// <returns>문자열</returns>
        public string ToString(int indentCount = 0)
        {
            string indentString = " ".GetRepeatString(indentCount);

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{indentString}addr         : {addr        }");
            stringBuilder.AppendLine($"{indentString}cluster_port : {cluster_port}");
            stringBuilder.AppendLine($"{indentString}auth_timeout : {auth_timeout}");

            return stringBuilder.ToString();
        }

        #endregion
    }

    /// <summary>
    /// varz
    /// </summary>
    public class varz
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 서버 ID - server_id

        /// <summary>
        /// 서버 ID
        /// </summary>
        public string server_id { get; set; }

        #endregion
        #region 버전 - version

        /// <summary>
        /// 버전
        /// </summary>
        public string version { get; set; }

        #endregion
        #region 원형 - proto

        /// <summary>
        /// 원형
        /// </summary>
        public int proto { get; set; }

        #endregion
        #region GO 언어 버전 - go

        /// <summary>
        /// GO 언어 버전
        /// </summary>
        public string go { get; set; }

        #endregion
        #region 호스트 - host

        /// <summary>
        /// 호스트
        /// </summary>
        public string host { get; set; }

        #endregion
        #region 인증 요구 여부 - auth_required

        /// <summary>
        /// 인증 요구 여부
        /// </summary>
        public bool auth_required { get; set; }

        #endregion
        #region 연결 URL 리스트 - connect_urls

        /// <summary>
        /// 연결 URL 리스트
        /// </summary>
        public List<string> connect_urls { get; set; }

        #endregion
        #region 주소 - addr

        /// <summary>
        /// 주소
        /// </summary>
        public string addr { get; set; }

        #endregion
        #region 최대 연결 수 - max_connections

        /// <summary>
        /// 최대 연결 수
        /// </summary>
        public int max_connections { get; set; }

        #endregion
        #region PING 주기 - ping_interval

        /// <summary>
        /// PING 주기
        /// </summary>
        public long ping_interval { get; set; }

        #endregion
        #region PING 최대 횟수 - ping_max

        /// <summary>
        /// PING 최대 횟수
        /// </summary>
        public int ping_max { get; set; }

        #endregion
        #region HTTP 호스트 - http_host

        /// <summary>
        /// HTTP 호스트
        /// </summary>
        public string http_host { get; set; }

        #endregion
        #region HTTP 포트 - http_port

        /// <summary>
        /// HTTP 포트
        /// </summary>
        public int http_port { get; set; }

        #endregion
        #region HTTPS 포트 - https_port

        /// <summary>
        /// HTTPS 포트
        /// </summary>
        public int https_port { get; set; }

        #endregion
        #region 인증 타임아웃 - auth_timeout

        /// <summary>
        /// 인증 타임아웃
        /// </summary>
        public int auth_timeout { get; set; }

        #endregion
        #region 최대 컨트롤 라인 - max_control_line

        /// <summary>
        /// 최대 컨트롤 라인
        /// </summary>
        public int max_control_line { get; set; }

        #endregion
        #region 클러스터 - cluster

        /// <summary>
        /// 클러스터
        /// </summary>
        public cluster cluster { get; set; }

        #endregion
        #region TLS 타임아웃 - tls_timeout

        /// <summary>
        /// TLS 타임아웃
        /// </summary>
        public double tls_timeout { get; set; }

        #endregion
        #region 포트 - port

        /// <summary>
        /// 포트
        /// </summary>
        public int port { get; set; }

        #endregion
        #region 최대 페이로드 - max_payload

        /// <summary>
        /// 최대 페이로드
        /// </summary>
        public int max_payload { get; set; }

        #endregion
        #region 시작 시간 - start

        /// <summary>
        /// 시작 시간
        /// </summary>
        public DateTime start { get; set; }

        #endregion
        #region 현재 시간 - now

        /// <summary>
        /// 현재 시간
        /// </summary>
        public DateTime now { get; set; }

        #endregion
        #region UP 시간 - uptime

        /// <summary>
        /// UP 시간
        /// </summary>
        public string uptime { get; set; }

        #endregion
        #region 메모리 - mem

        /// <summary>
        /// 메모리
        /// </summary>
        public long mem { get; set; }

        #endregion
        #region 코어 수 - cores

        /// <summary>
        /// 코어 수
        /// </summary>
        public int cores { get; set; }

        #endregion
        #region CPU - cpu

        /// <summary>
        /// CPU
        /// </summary>
        public double cpu { get; set; }

        #endregion
        #region 연결 수 - connections

        /// <summary>
        /// 연결 수
        /// </summary>
        public int connections { get; set; }

        #endregion
        #region 총 연결 수 - total_connections

        /// <summary>
        /// 총 연결 수
        /// </summary>
        public int total_connections { get; set; }

        #endregion
        #region 라우팅 수 - routes

        /// <summary>
        /// 라우팅 수
        /// </summary>
        public int routes { get; set; }

        #endregion
        #region 원격지 수 - remotes

        /// <summary>
        /// 원격지 수
        /// </summary>
        public int remotes { get; set; }

        #endregion
        #region 입력 메시지 수 - in_msgs

        /// <summary>
        /// 입력 메시지 수
        /// </summary>
        public long in_msgs { get; set; }

        #endregion
        #region 출력 메시지 수 - out_msgs

        /// <summary>
        /// 출력 메시지 수
        /// </summary>
        public long out_msgs { get; set; }

        #endregion
        #region 입력 바이트 수 - in_bytes

        /// <summary>
        /// 입력 바이트 수
        /// </summary>
        public long in_bytes { get; set; }

        #endregion
        #region 출력 바이트 수 - out_bytes

        /// <summary>
        /// 출력 바이트 수
        /// </summary>
        public long out_bytes { get; set; }

        #endregion
        #region SLOW 소비자 수 - slow_consumers

        /// <summary>
        /// SLOW 소비자 수
        /// </summary>
        public int slow_consumers { get; set; }

        #endregion
        #region 최대 보류 수 - max_pending

        /// <summary>
        /// 최대 보류 수
        /// </summary>
        public long max_pending { get; set; }

        #endregion
        #region 쓰기 데드라인 - write_deadline

        /// <summary>
        /// 쓰기 데드라인
        /// </summary>
        public long write_deadline { get; set; }

        #endregion
        #region 구독 수 - subscriptions

        /// <summary>
        /// 구독 수
        /// </summary>
        public int subscriptions { get; set; }

        #endregion
        #region HTTP 요청 상태 딕셔너리 - http_req_stats

        /// <summary>
        /// HTTP 요청 상태 딕셔너리
        /// </summary>
        public Dictionary<string, long> http_req_stats { get; set; }

        #endregion
        #region 구성 로드 시간 - config_load_time

        /// <summary>
        /// 구성 로드 시간
        /// </summary>
        public DateTime config_load_time { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"server_id         : {server_id        }");
            stringBuilder.AppendLine($"version           : {version          }");
            stringBuilder.AppendLine($"proto             : {proto            }");
            stringBuilder.AppendLine($"go                : {go               }");
            stringBuilder.AppendLine($"host              : {host             }");
            stringBuilder.AppendLine($"auth_required     : {auth_required    }");
            stringBuilder.AppendLine($"connect_urls");
            stringBuilder.AppendLine($"--------------------------------------------------");
            if(connect_urls != null && connect_urls.Count > 0)
            {
                foreach(string connect_url in connect_urls)
                {
                    stringBuilder.AppendLine($"    {connect_url}");
                }
            }
            stringBuilder.AppendLine($"--------------------------------------------------");
            stringBuilder.AppendLine($"addr              : {addr             }");
            stringBuilder.AppendLine($"max_connections   : {max_connections  }");
            stringBuilder.AppendLine($"ping_interval     : {ping_interval    }");
            stringBuilder.AppendLine($"ping_max          : {ping_max         }");
            stringBuilder.AppendLine($"http_host         : {http_host        }");
            stringBuilder.AppendLine($"http_port         : {http_port        }");
            stringBuilder.AppendLine($"https_port        : {https_port       }");
            stringBuilder.AppendLine($"auth_timeout      : {auth_timeout     }");
            stringBuilder.AppendLine($"max_control_line  : {max_control_line }");
            stringBuilder.AppendLine($"cluster           : {cluster          }");
            stringBuilder.AppendLine($"--------------------------------------------------");
            stringBuilder.AppendLine($"{cluster.ToString(4)}");
            stringBuilder.AppendLine($"--------------------------------------------------");
            stringBuilder.AppendLine($"tls_timeout       : {tls_timeout      }");
            stringBuilder.AppendLine($"port              : {port             }");
            stringBuilder.AppendLine($"max_payload       : {max_payload      }");
            stringBuilder.AppendLine($"start             : {start            }");
            stringBuilder.AppendLine($"now               : {now              }");
            stringBuilder.AppendLine($"uptime            : {uptime           }");
            stringBuilder.AppendLine($"mem               : {mem              }");
            stringBuilder.AppendLine($"cores             : {cores            }");
            stringBuilder.AppendLine($"cpu               : {cpu              }");
            stringBuilder.AppendLine($"connections       : {connections      }");
            stringBuilder.AppendLine($"total_connections : {total_connections}");
            stringBuilder.AppendLine($"routes            : {routes           }");
            stringBuilder.AppendLine($"remotes           : {remotes          }");
            stringBuilder.AppendLine($"in_msgs           : {in_msgs          }");
            stringBuilder.AppendLine($"out_msgs          : {out_msgs         }");
            stringBuilder.AppendLine($"in_bytes          : {in_bytes         }");
            stringBuilder.AppendLine($"out_bytes         : {out_bytes        }");
            stringBuilder.AppendLine($"slow_consumers    : {slow_consumers   }");
            stringBuilder.AppendLine($"max_pending       : {max_pending      }");
            stringBuilder.AppendLine($"write_deadline    : {write_deadline   }");
            stringBuilder.AppendLine($"subscriptions     : {subscriptions    }");
            stringBuilder.AppendLine($"http_req_stats");
            stringBuilder.AppendLine($"--------------------------------------------------");
            if(http_req_stats != null && http_req_stats.Count > 0)
            {
                int maximumKeyLength = 0;

                foreach(KeyValuePair<string, long> keyValuePair in http_req_stats)
                {
                    if(keyValuePair.Key.Length > maximumKeyLength)
                    {
                        maximumKeyLength = keyValuePair.Key.Length;
                    }
                }

                foreach(KeyValuePair<string, long> keyValuePair in http_req_stats)
                {
                    string key = $"{keyValuePair.Key}{" ".GetRepeatString(maximumKeyLength - keyValuePair.Key.Length)}";

                    stringBuilder.AppendLine($"    {key} : {keyValuePair.Value}");
                }
            }
            stringBuilder.AppendLine($"--------------------------------------------------");
            stringBuilder.AppendLine($"config_load_time  : {config_load_time }");

            return stringBuilder.ToString();
        }

        #endregion
    }
}