﻿using System;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            string serverAddress = "127.0.0.1";
            int    serverPort    = 20030;

            // 서버 정보를 구한다.
            varz varz = NATSHelper.GetVARZ(serverAddress, serverPort);
            
            Console.WriteLine(varz);
            
            Console.WriteLine();

            // 연결 정보를 구한다.
            connz connz = NATSHelper.GetCONNZ(serverAddress, serverPort);
            
            Console.WriteLine(connz);
            
            Console.WriteLine();

            // 라우팅 정보를 구한다.
            routez routez = NATSHelper.GetROUTEZ(serverAddress, serverPort);
            
            Console.WriteLine(routez);
            Console.WriteLine();

            // 구독 정보를 구한다.
            subsz subsz = NATSHelper.GetSUBSZ(serverAddress, serverPort);
            
            Console.WriteLine(subsz);
            
            Console.WriteLine();
        }

        #endregion
    }
}